C     ROUTINE columns  !!!
C
C    This program read add date&time to
C    STA_YYYMMDDHHMMR.dat files and read
C    TID_HFI_YYYYMMDDHHMM.log
C    rewrite it in a fixed column format 
C
C    Also calculate the global activity index
C

      DOUBLE PRECISION  ALATI(30),ALONG(30)
      DOUBLE PRECISION  result,resultIA,ActivityIndex
      DOUBLE PRECISION  resultSA,resultIASA,ActivityIndexSA
      DOUBLE PRECISION  AMP(30),POT(30),CONT(30)
      INTEGER VEL(30),AZI(30),PER(30),TrL(30),IA(30),IQ(30)
      integer IHE(30),IST(30),IFL(30),NW(30),IW(30) 
      CHARACTER*97 HEAD2
      CHARACTER*5 ESTAC(30)
      CHARACTER*12 TIMEC(30),TIME
      INTEGER ANY(1000),MES(1000),DIA(1000)
      DOUBLE PRECISION RESIDUS(2000),BACK(2000)
      DOUBLE PRECISION FORESIDUS(2000),FOBACK(2000)
      INTEGER YYYY,MONTH,DAY,HOUR,MINUT,A(1000),B(1000)
      CHARACTER*4 PAR(5),EXTI,EXTO
      CHARACTER*5 EXTS,ESTA,DDD
C      CHARACTER*12 TIME,TIME1	
      CHARACTER*8 HEAD
      CHARACTER*9 ACT,ACTSA
      CHARACTER*18 NAM
      CHARACTER*26 NAME_EXIT
      CHARACTER*24 NAMI
      CHARACTER*23 NOOMS,NAMO
      CHARACTER*43 FILENAME1
      
 1005 FORMAT(A7,A5,A1,I4,I2.2,I2.2,I2.2,I2.2,A1,A12,A5)

 1000 FORMAT(A97)
 4400 FORMAT(3I3,1X,A5,1X,A12,2F7.2,2I3,I5,F7.1,F7.2,F6.1
     * ,1X,2I5,1X,I2,1X,I3,1X,I3)
 4500 FORMAT(3I3,1X,A5,1X,A12,2F7.2,2I3,2X,A3,4X,A3,4X,A3
     * ,3X,A3,3X,A3,2X,A3,1X,I2,1X,I3,1X,I3)

 1200 FORMAT(A8)
 1100 FORMAT(I1,1X,A5,1X,A12,2F7.2,2I4) 
 1300 FORMAT(I4,I2,I2,I2,I2) 
 7000 FORMAT(4X,F8.2,F8.2,F8.2,F8.2)
 9000 FORMAT (A10,F5.2,1X,A5,F6.2,A1,1X,A14,F5.2,1X,A9)
 8100 FORMAT(I4'-'I2.2'-'I2.2,1X,I2.2':'I2.2,F8.2,F8.2,F8.2,F8.2)
 8200 FORMAT(I4'-'I2.2'-'I2.2,1X,I2.2':'I2.2,4X,A3,4X,A3,4X,A3,4X,A3)
      EXTI='.log'
      EXTO='.dat'
      EXTS='R.dat'
C
      OPEN(3,FILE='inici3',STATUS='OLD')
      READ(3,1200) HEAD
    5 READ(3,1100,ERR=5,END=999) IFLAGD,ESTA,TIME,ALATID,ALONGD,
     * IHED,ISTD

      NAMI='TID_HFI_'//TIME//EXTI
      NAMO='OE_HFI_'//TIME//EXTI
      NOOMS=ESTA//'_'//TIME//EXTS

      numestas=0
      sumaTrL=0
      sumaIA=0      
      nq=0
      numestasSA=0
      sumaTrLSA=0
      sumaIASA=0      
      nqSA=0

C     reading and rewriting R.dat files with 
C     time information

      READ(TIME,1300)YYYY,MONTH,DAY,HOUR,MINUT
      CALL JD(YYYY,MONTH,DAY,IJD)
      IHOUR=HOUR-6
      IF(IHOUR.lt.0) THEN
	IHOUR=HOUR-6+24
        IJD=IJD-1
	CALL DATE(IJD,IYY,IMONTH,IDAY)
        ELSE 
	CALL DATE(IJD,IYY,IMONTH,IDAY)
      ENDIF

      A=MINUT
      B=IHOUR
      ANY=IYY
      MES=IMONTH
      DIA=IDAY
      WRITE(FILENAME1,1005) 'OE_HFI_',ESTA,'_',IYY,IMONTH,IDAY,
     * IHOUR,MINUT,'_',TIME,'R.dat'
      OPEN(UNIT=1,FILE=FILENAME1,STATUS='UNKNOWN')

      IF (IFLAGD.EQ.0) GOTO 3
      open(2,FILE=NOOMS,STATUS='OLD')
    3 CONTINUE

      DO J=1,360
      B=B
      ANY=ANY
      MES=MES
      DIA=DIA
      A=A+1
      
      IF (A(J).GE.60) THEN
	A=0
        B=B+1
	      IF (B(J).GE.24) THEN
               B=B-24
               IJD=IJD+1
               CALL DATE(IJD,IYY,IMONTH,IDAY)
               ANY=IYY
               MES=IMONTH
               DIA=IDAY
	      ENDIF
      ENDIF
      IF (IFLAGD.EQ.1) THEN
      read(2,7000,END=888) FORESIDUS(J),FOBACK(J),RESIDUS(J),
     * BACK(J)
  888 CONTINUE
      WRITE(1,8100)ANY(J),MES(J),DIA(J),B(J),A(J),
     * FORESIDUS(J),FOBACK(J),
     * RESIDUS(J),BACK(J)
      ELSE
      WRITE(1,8200)ANY(J),MES(J),DIA(J),B(J),A(J),
     * 'NaN','NaN','NaN','NaN'
      ENDIF 
      ENDDO

      GOTO 5
  999 CONTINUE

      CLOSE(3)

      CLOSE(1)
      CLOSE(2)

C     reading and rewriting .log files 
C     changing -9999 for NaN
C     and also calculation of ctivity index as TrLAverage * area 

      OPEN(7,FILE=NAMO,STATUS='UNKNOWN') 

      
      OPEN(8,FILE=NAMI,STATUS='OLD') 
      READ(8,1000) HEAD2
      WRITE(7,*)'TechTIDE project Ebre Observatory HF-Interferometry'
      WRITE(7,*) 'NT ST FL  STA    DATE&TIME   ALATI  ALONG NW IW PERIO
     *POWER  AMPLI SPCONT  VEL  AZI TrL IQ  IR '           

      K=0
    7 CONTINUE
      K=K+1
C  	
      READ(8,*,END=998) IHE(K),IST(K),IFL(K),ESTAC(K),TIMEC(K),
     * ALATI(K),ALONG(K),NW(K),IW(K),PER(K),POT(K),AMP(K),
     * CONT(K),VEL(K),AZI(K),TrL(K),IQ(K),IA(K) 

      IF (IHE(K).eq.1) THEN
      IF (IFL(K).eq.1) THEN
      numestas=numestas+1      
      IF (IQ(K).gt.0) THEN
      sumaTrL=TrL(K)+sumaTrL
      sumaIA=IQ(K)+sumaIA
      else
      nq=nq+1
      ENDIF
      ENDIF
      ELSE
      IF (IFL(K).eq.1) THEN
      numestasSA=numestasSA+1      
      IF (IQ(K).gt.0) THEN
      sumaTrLSA=TrL(K)+sumaTrLSA
      sumaIASA=IQ(K)+sumaIASA
      else
      nqSA=nqSA+1
      ENDIF
      ENDIF
      
      ENDIF

      GOTO 7
  998 CONTINUE
      if (numestas.eq.nq) then
            result=0
            resultIA=0
      else
            result=sumaTrL/(numestas-nq) 
            resultIA=sumaIA/numestas 
      endif
      ActivityIndex=result*resultIA/100
      IF (ActivityIndex.lt.0.90) ACT='NO TID'
      IF (ActivityIndex.ge.0.90 .and. ActivityIndex.lt.1.75)
     * ACT='Uncertain'
      IF (ActivityIndex.ge.1.75) ACT='TID'

      if (numestasSA.eq.nqSA) then
            resultSA=0
            resultIASA=0
      else
            resultSA=sumaTrLSA/(numestasSA-nqSA) 
            resultIASA=sumaIASA/numestasSA 
      endif
      ActivityIndexSA=resultSA*resultIASA/100
      IF (ActivityIndexSA.lt.0.90) ACTSA='NO TID'
      IF (ActivityIndexSA.ge.0.90 .and. ActivityIndexSA.lt.1.75)
     * ACTSA='Uncertain'
      IF (ActivityIndexSA.ge.1.75) ACTSA='TID'

      CLOSE(8)
      n=K-1
      do K=1,n 
      if (VEL(K).eq.-999) then
      WRITE(7,4500) IHE(K),IST(K),IFL(K),ESTAC(K),TIMEC(K),
     * ALATI(K),ALONG(K),NW(K),IW(K),'NaN','NaN',
     * 'NaN','NaN','NaN','NaN',TrL(K),IQ(K),IA(K)
      else
      WRITE(7,4400) IHE(K),IST(K),IFL(K),ESTAC(K),TIMEC(K),
     * ALATI(K),ALONG(K),NW(K),IW(K),PER(K),POT(K),
     * AMP(K),CONT(K),VEL(K),AZI(K),TrL(K),IQ(K),IA(K)
      ENDIF
      ENDDO
      WRITE(7,9000) 'EU TrL AV=',result,'Area=',resultIA,'%',
     * 'ActivityIndex=',ActivityIndex,ACT
      WRITE(7,9000) 'SA TrL AV=',resultSA,'Area=',resultIASA,'%',
     * 'ActivityIndex=',ActivityIndexSA,ACTSA
      CLOSE(7)
      END