      SUBROUTINE DATE (JD,I,J,K)
C
C  COMPUTES CALENDAR DATE FROM THE JULIAN ONE
C
C  PARAMETERS
C     JD  JULIAN DATE
C     I   YEAR
C     J   MONTH
C     K   DAY
C
C  SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED
C     NONE
C
C  SOURCE
C     H.F.FLIEGEL, T.C.VAN FLANDERN, 1968, CACM 11,657
C
      L=JD+68569
      N=4*L/146097
      L=L-(146097*N+3)/4
      I=4000*(L+1)/1461001
      L=L-1461*I/4+31
      J=80*L/2447
      K=L-2447*J/80
      L=J/11
      J=J+2-12*L
      I=100*(N-49)+I+L
      RETURN
      END
